diff --git a/Makefile b/Makefile
index f4d4d6b..74ce447 100644
--- a/Makefile
+++ b/Makefile
@@ -20,7 +20,7 @@ CPPFLAGS += "-DVERSION_MAJOR=${VERSION_MAJOR}"
 CPPFLAGS += "-DVERSION_MINOR=${VERSION_MINOR}"
 CPPFLAGS += "-DVERSION_REV=${VERSION_REV}"
 
-all: options ${PLUGIN}.so
+all: options ${PLUGIN}.dylib
 
 zathura-version-check:
 ifneq ($(ZATHURA_VERSION_CHECK), 0)
@@ -48,19 +48,19 @@ options:
 ${OBJECTS}:  config.mk zathura-version-check
 ${DOBJECTS}: config.mk zathura-version-check
 
-${PLUGIN}.so: ${OBJECTS}
+${PLUGIN}.dylib: ${OBJECTS}
 	$(ECHO) LD $@
-	$(QUIET)${CC} -shared ${LDFLAGS} -o $@ $(OBJECTS) ${LIBS}
+	$(QUIET)${CC} -Wl,-dylib_install_name,${PLUGIN}.dylib -Wl,-bundle_loader,${PREFIX}/bin/zathura -bundle ${LDFLAGS} -o $@ $(OBJECTS) ${LIBS}
 
-${PLUGIN}-debug.so: ${DOBJECTS}
+${PLUGIN}-debug.dylib: ${DOBJECTS}
 	$(ECHO) LD $@
 	$(QUIET)${CC} -shared ${LDFLAGS} -o $@ $(DOBJECTS) ${LIBS}
 
 clean:
-	$(QUIET)rm -rf ${OBJECTS} ${DOBJECTS} $(PLUGIN).so $(PLUGIN)-debug.so \
+	$(QUIET)rm -rf ${OBJECTS} ${DOBJECTS} $(PLUGIN).dylib $(PLUGIN)-debug.dylib \
 		doc .depend ${PROJECT}-${VERSION}.tar.gz zathura-version-check
 
-debug: options ${PLUGIN}-debug.so
+debug: options ${PLUGIN}-debug.dylib
 
 dist: clean
 	$(QUIET)mkdir -p ${PROJECT}-${VERSION}
@@ -77,7 +77,7 @@ doc: clean
 install: all
 	$(ECHO) installing ${PLUGIN} plugin
 	$(QUIET)mkdir -p ${DESTDIR}${PLUGINDIR}
-	$(QUIET)cp -f ${PLUGIN}.so ${DESTDIR}${PLUGINDIR}
+	$(QUIET)cp -f ${PLUGIN}.dylib ${DESTDIR}${PLUGINDIR}
 	$(QUIET)mkdir -m 755 -p ${DESTDIR}${DESKTOPPREFIX}
 	$(ECHO) installing desktop file
 	$(QUIET)install -m 644 ${PROJECT}.desktop ${DESTDIR}${DESKTOPPREFIX}
@@ -85,11 +85,11 @@ install: all
 
 uninstall:
 	$(ECHO) uninstalling ${PLUGIN} plugin
-	$(QUIET)rm -f ${DESTDIR}${PLUGINDIR}/${PLUGIN}.so
-	$(QUIET)rmdir --ignore-fail-on-non-empty ${DESTDIR}${PLUGINDIR} 2> /dev/null
+	$(QUIET)rm -f ${DESTDIR}${PLUGINDIR}/${PLUGIN}.dylib
+	$(QUIET)rmdir ${DESTDIR}${PLUGINDIR} 2> /dev/null
 	$(ECHO) removing desktop file
 	$(QUIET)rm -f ${DESTDIR}${DESKTOPPREFIX}/${PROJECT}.desktop
-	$(QUIET)rmdir --ignore-fail-on-non-empty ${DESTDIR}${DESKTOPPREFIX} 2> /dev/null
+	$(QUIET)rmdir ${DESTDIR}${DESKTOPPREFIX} 2> /dev/null
 
 -include $(wildcard .depend/*.dep)
 
